#include "hilos.h"
#include "lista.h"

void IntroducirHilo(int nid, TLista *tllista)
{
	if (tllista->cabeza == -1) {
		tllista->cabeza = tllista->cola = nid;
		thTablaHilos[nid].antid = -1;
	}
	else {
		thTablaHilos[tllista->cola].sigid = nid;
		thTablaHilos[nid].antid = tllista->cola;
		tllista->cola = nid;
	}
	thTablaHilos[nid].sigid = -1;
}

int ExtraerHilo(TLista *tllista)
{
	int ID;

	if (tllista->cabeza == -1) return -1;
	if (tllista->cabeza == tllista->cola) {
		ID = tllista->cabeza;
		tllista->cabeza = tllista->cola = -1;
	}
	else {
		ID = tllista->cabeza;
		tllista->cabeza = thTablaHilos[tllista->cabeza].sigid;
		thTablaHilos[tllista->cabeza].antid = -1;
	}
	return ID;
}

void BorrarHilo(int nid, TLista *tllista)
{
	int antID, sigID;

	if (tllista->cabeza == -1) return;
	antID = thTablaHilos[nid].antid;
	sigID = thTablaHilos[nid].sigid;
	if (antID == -1) tllista->cabeza = sigID;
	else thTablaHilos[antID].sigid = sigID;

	if (sigID == -1) tllista->cola = antID;
	else thTablaHilos[sigID].antid = antID;
}

void InsertarHilo(int nid, int nsig, TLista *tllista)
{
	int antID;

	if ((tllista->cabeza == -1) || (nsig == -1)) {
		IntroducirHilo(nid, tllista);
		return;
	}

	antID = thTablaHilos[nsig].antid;

	if(antID != -1)
		thTablaHilos[antID].sigid = nid;
	else tllista -> cabeza = nid;

	thTablaHilos[nid].antid = antID;
	thTablaHilos[nid].sigid = nsig;
	thTablaHilos[nsig].antid = nid;
}

